<?php

/**
 * @package CRM
 * @copyright CiviCRM LLC (c) 2004-2019
 *
 * Generated from /Users/totten/bknix/build/dmaster/web/sites/all/modules/civicrm/ext/afform/log/xml/schema/CRM/AfformLog/AfformLog.xml
 * DO NOT EDIT.  Generated by CRM_Core_CodeGen
 * (GenCodeChecksum:5088216a0afebdde8b1243d17e769376)
 */

/**
 * Database access object for the AfformLog entity.
 */
class CRM_AfformLog_DAO_AfformLog extends CRM_Core_DAO {

  /**
   * Static instance to hold the table name.
   *
   * @var string
   */
  public static $_tableName = 'civicrm_afform_log';

  /**
   * Should CiviCRM log any modifications to this table in the civicrm_log table.
   *
   * @var bool
   */
  public static $_log = TRUE;

  /**
   * Unique AfformLog ID
   *
   * @var int
   */
  public $id;

  /**
   * Name of the form
   *
   * @var string
   */
  public $form;

  /**
   * Type of form event (e.g. "submit")
   *
   * @var string
   */
  public $type;

  /**
   * Form submission data
   *
   * @var longtext
   */
  public $data;

  /**
   * When this logged event occurred.
   *
   * @var timestamp
   */
  public $created_date;

  /**
   * FK to civicrm_contact, who created this log record.
   *
   * @var int
   */
  public $created_id;

  /**
   * Class constructor.
   */
  public function __construct() {
    $this->__table = 'civicrm_afform_log';
    parent::__construct();
  }

  /**
   * Returns foreign keys and entity references.
   *
   * @return array
   *   [CRM_Core_Reference_Interface]
   */
  public static function getReferenceColumns() {
    if (!isset(Civi::$statics[__CLASS__]['links'])) {
      Civi::$statics[__CLASS__]['links'] = static::createReferenceColumns(__CLASS__);
      Civi::$statics[__CLASS__]['links'][] = new CRM_Core_Reference_Basic(self::getTableName(), 'created_id', 'civicrm_contact', 'id');
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'links_callback', Civi::$statics[__CLASS__]['links']);
    }
    return Civi::$statics[__CLASS__]['links'];
  }

  /**
   * Returns all the column names of this table
   *
   * @return array
   */
  public static function &fields() {
    if (!isset(Civi::$statics[__CLASS__]['fields'])) {
      Civi::$statics[__CLASS__]['fields'] = [
        'id' => [
          'name' => 'id',
          'type' => CRM_Utils_Type::T_INT,
          'description' => CRM_AfformLog_ExtensionUtil::ts('Unique AfformLog ID'),
          'required' => TRUE,
          'where' => 'civicrm_afform_log.id',
          'table_name' => 'civicrm_afform_log',
          'entity' => 'AfformLog',
          'bao' => 'CRM_AfformLog_DAO_AfformLog',
          'localizable' => 0,
        ],
        'form' => [
          'name' => 'form',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => CRM_AfformLog_ExtensionUtil::ts('Form'),
          'description' => CRM_AfformLog_ExtensionUtil::ts('Name of the form'),
          'maxlength' => 64,
          'size' => CRM_Utils_Type::BIG,
          'where' => 'civicrm_afform_log.form',
          'table_name' => 'civicrm_afform_log',
          'entity' => 'AfformLog',
          'bao' => 'CRM_AfformLog_DAO_AfformLog',
          'localizable' => 0,
          'html' => [
            'type' => 'Select',
          ],
          'pseudoconstant' => [
            'callback' => 'CRM_AfformLog_BAO_AfformLog::getFormNames',
          ],
        ],
        'type' => [
          'name' => 'type',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => CRM_AfformLog_ExtensionUtil::ts('Type'),
          'description' => CRM_AfformLog_ExtensionUtil::ts('Type of form event (e.g. "submit")'),
          'maxlength' => 32,
          'size' => CRM_Utils_Type::MEDIUM,
          'where' => 'civicrm_afform_log.type',
          'table_name' => 'civicrm_afform_log',
          'entity' => 'AfformLog',
          'bao' => 'CRM_AfformLog_DAO_AfformLog',
          'localizable' => 0,
          'html' => [
            'type' => 'Select',
          ],
          'pseudoconstant' => [
            'callback' => 'CRM_AfformLog_BAO_AfformLog::getLogTypes',
          ],
        ],
        'data' => [
          'name' => 'data',
          'type' => CRM_Utils_Type::T_LONGTEXT,
          'title' => CRM_AfformLog_ExtensionUtil::ts('Data'),
          'description' => CRM_AfformLog_ExtensionUtil::ts('Form submission data'),
          'where' => 'civicrm_afform_log.data',
          'table_name' => 'civicrm_afform_log',
          'entity' => 'AfformLog',
          'bao' => 'CRM_AfformLog_DAO_AfformLog',
          'localizable' => 0,
          'serialize' => self::SERIALIZE_JSON,
        ],
        'created_date' => [
          'name' => 'created_date',
          'type' => CRM_Utils_Type::T_TIMESTAMP,
          'title' => CRM_AfformLog_ExtensionUtil::ts('Timestamp'),
          'description' => CRM_AfformLog_ExtensionUtil::ts('When this logged event occurred.'),
          'required' => TRUE,
          'where' => 'civicrm_afform_log.created_date',
          'default' => 'CURRENT_TIMESTAMP',
          'table_name' => 'civicrm_afform_log',
          'entity' => 'AfformLog',
          'bao' => 'CRM_AfformLog_DAO_AfformLog',
          'localizable' => 0,
        ],
        'created_id' => [
          'name' => 'created_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => CRM_AfformLog_ExtensionUtil::ts('Created By'),
          'description' => CRM_AfformLog_ExtensionUtil::ts('FK to civicrm_contact, who created this log record.'),
          'where' => 'civicrm_afform_log.created_id',
          'table_name' => 'civicrm_afform_log',
          'entity' => 'AfformLog',
          'bao' => 'CRM_AfformLog_DAO_AfformLog',
          'localizable' => 0,
          'FKClassName' => 'CRM_Contact_DAO_Contact',
        ],
      ];
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'fields_callback', Civi::$statics[__CLASS__]['fields']);
    }
    return Civi::$statics[__CLASS__]['fields'];
  }

  /**
   * Return a mapping from field-name to the corresponding key (as used in fields()).
   *
   * @return array
   *   Array(string $name => string $uniqueName).
   */
  public static function &fieldKeys() {
    if (!isset(Civi::$statics[__CLASS__]['fieldKeys'])) {
      Civi::$statics[__CLASS__]['fieldKeys'] = array_flip(CRM_Utils_Array::collect('name', self::fields()));
    }
    return Civi::$statics[__CLASS__]['fieldKeys'];
  }

  /**
   * Returns the names of this table
   *
   * @return string
   */
  public static function getTableName() {
    return self::$_tableName;
  }

  /**
   * Returns if this table needs to be logged
   *
   * @return bool
   */
  public function getLog() {
    return self::$_log;
  }

  /**
   * Returns the list of fields that can be imported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &import($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getImports(__CLASS__, 'afform_log', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of fields that can be exported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &export($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getExports(__CLASS__, 'afform_log', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of indices
   *
   * @param bool $localize
   *
   * @return array
   */
  public static function indices($localize = TRUE) {
    $indices = [
      'UI_form_type' => [
        'name' => 'UI_form_type',
        'field' => [
          0 => 'form',
          1 => 'type',
        ],
        'localizable' => FALSE,
        'sig' => 'civicrm_afform_log::0::form::type',
      ],
    ];
    return ($localize && !empty($indices)) ? CRM_Core_DAO_AllCoreTables::multilingualize(__CLASS__, $indices) : $indices;
  }

}
