<?php

require_once 'afform_log.civix.php';
use CRM_AfformLog_ExtensionUtil as E;

/**
 * Implements hook_civicrm_config().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_config/ 
 */
function afform_log_civicrm_config(&$config) {
  _afform_log_civix_civicrm_config($config);

  if (isset(Civi::$statics[__FUNCTION__])) {
    return;
  }
  Civi::$statics[__FUNCTION__] = 1;

  Civi::dispatcher()->addListener('civi.api.prepare', '_afform_log_wrap', Civi\API\Events::W_LATE);
}

/**
 * @param \Civi\API\Event\PrepareEvent $event
 */
function _afform_log_wrap($event) {
  $a = $event->getApiRequest();
  switch ($a['entity'] . '.' . $a['action']) {
    case 'Afform.prefill':
      // $event->wrapApi('_afform_log_wrap_prefill');
      break;

    case 'Afform.submit':
      // $event->wrapApi('_afform_log_wrap_submit');
      break;
  }
}

/**
 * Handle the Mailing.submit API.
 *
 * @param \Civi\Api4\Action\Afform\Prefill $apiRequest
 *   The submitted API request.
 * @param callable $continue
 *   The original/upstream implementation of Mailing.submit API.
 * @return array
 * @throws \API_Exception
 */
function _afform_log_wrap_prefill(\Civi\Api4\Action\Afform\Prefill $apiRequest, $continue) {
  // FIXME: Get a reference to the form. Check which logging is active.
  \Civi\Api4\AfformLog::create()
    ->setCheckPermissions(FALSE)
    ->addValue('name', $apiRequest->getName())
    ->addValue('type', 'read')
    ->addValue('data', [
      // ...
    ])
    ->execute();
  return $continue($apiRequest);
}

/**
 * Implements hook_civicrm_xmlMenu().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_xmlMenu
 */
function afform_log_civicrm_xmlMenu(&$files) {
  _afform_log_civix_civicrm_xmlMenu($files);
}

/**
 * Implements hook_civicrm_install().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_install
 */
function afform_log_civicrm_install() {
  _afform_log_civix_civicrm_install();
}

/**
 * Implements hook_civicrm_postInstall().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_postInstall
 */
function afform_log_civicrm_postInstall() {
  _afform_log_civix_civicrm_postInstall();
}

/**
 * Implements hook_civicrm_uninstall().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_uninstall
 */
function afform_log_civicrm_uninstall() {
  _afform_log_civix_civicrm_uninstall();
}

/**
 * Implements hook_civicrm_enable().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_enable
 */
function afform_log_civicrm_enable() {
  _afform_log_civix_civicrm_enable();
}

/**
 * Implements hook_civicrm_disable().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_disable
 */
function afform_log_civicrm_disable() {
  _afform_log_civix_civicrm_disable();
}

/**
 * Implements hook_civicrm_upgrade().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_upgrade
 */
function afform_log_civicrm_upgrade($op, CRM_Queue_Queue $queue = NULL) {
  return _afform_log_civix_civicrm_upgrade($op, $queue);
}

/**
 * Implements hook_civicrm_managed().
 *
 * Generate a list of entities to create/deactivate/delete when this module
 * is installed, disabled, uninstalled.
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_managed
 */
function afform_log_civicrm_managed(&$entities) {
  _afform_log_civix_civicrm_managed($entities);
}

/**
 * Implements hook_civicrm_caseTypes().
 *
 * Generate a list of case-types.
 *
 * Note: This hook only runs in CiviCRM 4.4+.
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_caseTypes
 */
function afform_log_civicrm_caseTypes(&$caseTypes) {
  _afform_log_civix_civicrm_caseTypes($caseTypes);
}

/**
 * Implements hook_civicrm_angularModules().
 *
 * Generate a list of Angular modules.
 *
 * Note: This hook only runs in CiviCRM 4.5+. It may
 * use features only available in v4.6+.
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_angularModules
 */
function afform_log_civicrm_angularModules(&$angularModules) {
  _afform_log_civix_civicrm_angularModules($angularModules);
}

/**
 * Implements hook_civicrm_alterSettingsFolders().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_alterSettingsFolders
 */
function afform_log_civicrm_alterSettingsFolders(&$metaDataFolders = NULL) {
  _afform_log_civix_civicrm_alterSettingsFolders($metaDataFolders);
}

/**
 * Implements hook_civicrm_entityTypes().
 *
 * Declare entity types provided by this module.
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_entityTypes
 */
function afform_log_civicrm_entityTypes(&$entityTypes) {
  _afform_log_civix_civicrm_entityTypes($entityTypes);
}

/**
 * Implements hook_civicrm_thems().
 */
function afform_log_civicrm_themes(&$themes) {
  _afform_log_civix_civicrm_themes($themes);
}

// --- Functions below this ship commented out. Uncomment as required. ---

/**
 * Implements hook_civicrm_preProcess().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_preProcess
 *
function afform_log_civicrm_preProcess($formName, &$form) {

} // */

/**
 * Implements hook_civicrm_navigationMenu().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_navigationMenu
 *
function afform_log_civicrm_navigationMenu(&$menu) {
  _afform_log_civix_insert_navigation_menu($menu, 'Mailings', array(
    'label' => E::ts('New subliminal message'),
    'name' => 'mailing_subliminal_message',
    'url' => 'civicrm/mailing/subliminal',
    'permission' => 'access CiviMail',
    'operator' => 'OR',
    'separator' => 0,
  ));
  _afform_log_civix_navigationMenu($menu);
} // */

/**
 * Implements hook_civicrm_permission.
 *
 * @see CRM_Utils_Hook::permission()
 */
function afform_log_civicrm_permission(&$permissions) {
  $permissions = [
    'administer afform logs' => [
      E::ts('Afform: administer logs'),
      E::ts('Manually create, edit, delete log entries'),
    ],
    'delete afform logs' => [
      E::ts('Afform: Delete logs'),
      E::ts('Manually delete log entries'),
    ],
    'view all afform logs' => [
      E::ts('Afform: view all logs'),
      E::ts('View form-submission logs'),
    ],
  ];
  // WISHLIST: view any logs submitted by you
  // WISHLIST: view any logs for a form that you have access to administer
  return $permissions;
}
